
-- Create the addon main instance
local PartyFramesImproved = CreateFrame('Button', 'PartyFramesImproved');

-- Announce the Addon in the chat frame
print("PartyFramesImproved Loaded")

-- Event listener to make sure we enable the addon at the right time
function PartyFramesImproved:PLAYER_ENTERING_WORLD()
	EnablePartyFramesImproved();
end

function EnablePartyFramesImproved()

	-- Hook PartyMemberFrame functions
	hooksecurefunc("PartyMemberFrame_ToPlayerArt", PartyFramesImproved_PartyMemberFrame_ToPlayerArt);
	hooksecurefunc("PartyMemberFrame_ToVehicleArt", PartyFramesImproved_PartyMemberFrame_ToVehicleArt);
	hooksecurefunc("PartyMemberFrame_UpdateNotPresentIcon", PartyFramesImproved_PartyMemberFrame_UpdateNotPresentIcon);
	hooksecurefunc("HealthBar_OnValueChanged", PartyFramesImproved_Style_PartyMemberColor);
	hooksecurefunc("UnitFrameHealthBar_Update",PartyFramesImproved_Style_PartyMemberColor);
	
	-- Set up some stylings
	PartyFramesImproved_Style_PartyMemberFrame1();
end

-- Color Funtion
function PartyFramesImproved_Style_PartyMemberColor()
		for i = 1, GetNumGroupMembers() - 1 do
			local unit = "party"..i	
				if not InCombatLockdown() then
					_G["PartyMemberFrame"..i.."HealthBar"]:SetStatusBarColor(UnitColor("party"..i));
					_G["PartyMemberFrame"..i.."HealthBar"].lockColor = true
				end
	end
end

--Party Memeber Frame Styles

function PartyFramesImproved_Style_PartyMemberFrame1()
		for i = 1, GetNumGroupMembers() - 1 do
			local unit = "party"..i	
				if not InCombatLockdown() then
				-- Text
					_G["PartyMemberFrame"..i.."Name"]:SetPoint("BOTTOMLEFT",57,35)
					_G["PartyMemberFrame"..i.."HealthBarText"]:SetPoint("BOTTOM",10,20)
					_G["PartyMemberFrame"..i.."ManaBarText"]:SetPoint("BOTTOM",10,7)
				-- Border Texture
					_G["PartyMemberFrame"..i.."Texture"]:SetPoint("TOPLEFT",0,12)
					_G["PartyMemberFrame"..i.."Texture"]:SetHeight(75)
					_G["PartyMemberFrame"..i.."Texture"]:SetWidth(150)
				-- Border Flash
					_G["PartyMemberFrame"..i.."Flash"]:SetPoint("TOPLEFT",0,12)
					_G["PartyMemberFrame"..i.."Flash"]:SetHeight(75)
					_G["PartyMemberFrame"..i.."Flash"]:SetWidth(150)
				-- Health Bar
					_G["PartyMemberFrame"..i.."HealthBar"]:ClearAllPoints()
					_G["PartyMemberFrame"..i.."HealthBar"]:SetPoint("TOPLEFT",55,-7)
					_G["PartyMemberFrame"..i.."HealthBar"]:SetHeight(27)
					_G["PartyMemberFrame"..i.."HealthBar"]:SetWidth(80)
				-- Mana Bar
					_G["PartyMemberFrame"..i.."ManaBar"]:ClearAllPoints()
					_G["PartyMemberFrame"..i.."ManaBar"]:SetPoint("TOPLEFT",55,-34)
					_G["PartyMemberFrame"..i.."ManaBar"]:SetHeight(10)
					_G["PartyMemberFrame"..i.."ManaBar"]:SetWidth(80)
				-- Portrait
					_G["PartyMemberFrame"..i.."Portrait"]:SetPoint("TOPLEFT",7,-2)
					_G["PartyMemberFrame"..i.."Portrait"]:SetHeight(43)
					_G["PartyMemberFrame"..i.."Portrait"]:SetWidth(43)
				-- Background
					_G["PartyMemberFrame"..i.."Background"]:ClearAllPoints()
					_G["PartyMemberFrame"..i.."Background"]:SetPoint("TOPLEFT",55,-7)
					_G["PartyMemberFrame"..i.."Background"]:SetHeight(35)
					_G["PartyMemberFrame"..i.."Background"]:SetWidth(80)				
				end
		
			_G["PartyMemberFrame"..i.."Texture"]:SetTexture("Interface\\Addons\\PartyFramesImproved\\Textures\\PartyFramesImproved-UI-PartyFrame")
			_G["PartyMemberFrame"..i.."Flash"]:SetTexture("Interface\\Addons\\PartyFramesImproved\\Textures\\PartyFramesImproved-UI-PARTYFRAME-FLASH");
			-- _G["PartyMemberFrame"..i.."HealthBar"]:SetStatusBarColor(UnitColor("party"..i));
			-- _G["PartyMemberFrame"..i.."HealthBar"].lockColor = true
		end
end



function PartyFramesImproved_PartyMemberFrame_ToPlayerArt(self)
	if not InCombatLockdown() then
		PartyFramesImproved_Style_PartyMemberFrame1();
	end
end

function PartyFramesImproved_PartyMemberFrame_ToVehicleArt(self)

	if not InCombatLockdown() then
		for i = 1, GetNumGroupMembers() - 1 do
			local unit = "party"..i
				if UnitInVehicle("party"..i) then
					_G["PartyMemberFrame"..i.."VehicleTexture"]:SetTexture("Interface\\Addons\\PartyFramesImproved\\Textures\\PartyFramesImproved-UI-VEHICLES-PARTYFRAME")
					_G["PartyMemberFrame"..i.."VehicleTexture"]:SetPoint("TOPLEFT",0,12)
					_G["PartyMemberFrame"..i.."VehicleTexture"]:SetHeight(75)
					_G["PartyMemberFrame"..i.."VehicleTexture"]:SetWidth(150)

				end
		end
	end
end

function PartyFramesImproved_PartyMemberFrame_UpdateNotPresentIcon(self)
	local id = self:GetID();
	local partyID = "party"..id;
	
	local inPhase = UnitInPhase(partyID);
	
	if ( UnitInOtherParty(partyID) ) then
		self.notPresentIcon:SetPoint("LEFT",150,-1)
	elseif ( not inPhase and UnitExists(partyID) ) then
		self.notPresentIcon:SetPoint("LEFT",150,-1)
	
	end
end


-- Color Healthbars to Class Colors
function UnitColor(unit)
	local r, g, b;
	if ( ( not UnitIsPlayer(unit) ) and ( ( not UnitIsConnected(unit) ) or ( UnitIsDeadOrGhost(unit) ) ) ) then
		--Color it gray
		r, g, b = 0.5, 0.5, 0.5;
	elseif ( UnitIsPlayer(unit) ) then
		--Try to color it by class.
		local localizedClass, englishClass = UnitClass(unit);
		local classColor = RAID_CLASS_COLORS[englishClass];
		if ( classColor ) then
			r, g, b = classColor.r, classColor.g, classColor.b;
		else
			if ( UnitIsFriend("player", unit) ) then
				r, g, b = 0.0, 1.0, 0.0;
			else
				r, g, b = 1.0, 0.0, 0.0;
			end
		end
	else
		r, g, b = UnitSelectionColor(unit);
	end
	
	return r, g, b;
end

-- Bootstrap
function PartyFramesImproved_StartUp(self)
	self:SetScript('OnEvent', function(self, event) self[event](self) end);
	self:RegisterEvent('PLAYER_ENTERING_WORLD');
end

PartyFramesImproved_StartUp(PartyFramesImproved);